from rox import g

class CtxMenuWidget:
  """Widget with context menu capabilities."""

  def ctx_menu_enable(self):
    self.connect("button-press-event", self._ctx_menu_button_press)    

  def _ctx_menu_button_press(self, w, e):
    if e.type == g.gdk.BUTTON_PRESS and e.button == 3:
      self.ctx_menu_popup()
      return True
    return False

  def ctx_menu_new(self):
    return g.Menu()

  def ctx_menu_popup(self, time=None):
    m = self.ctx_menu_new()
    self.ctx_menu_fill(m)
    m.show_all()
    try: pm = self.ctx_menu_position
    except AttributeError: pm = None
    if time is None: time = g.get_current_event_time()
    m.popup(None, None, pm, 0, time)

  def ctx_menu_fill(self, menu):
    pass

  def ctx_menu_append(self, menu, item, callback):
    item.connect("activate", callback)
    menu.append(item)
