import os.path
from rox import g

TARGET_URILIST = 1

class DndSourceWidget:
  """Widget that can act as Drag and Drop source."""

  def dnd_source_enable(self):
    self.drag_source_set(g.gdk.BUTTON1_MASK,
        [("text/uri-list", 0, TARGET_URILIST)],
        g.gdk.ACTION_DEFAULT|g.gdk.ACTION_COPY|g.gdk.ACTION_LINK|
        g.gdk.ACTION_PRIVATE|g.gdk.ACTION_ASK)
    self.connect("drag-data-get", self._dnd_source_data_get)
    self.connect("drag-begin", self._dnd_source_drag_begin)

  def _dnd_source_data_get(self, w, c, s, i, t):
    s.set(s.target, 8, self.dnd_source_get_uri() + "\r\n")

  def _dnd_source_drag_begin(self, w, c):
    p = self.dnd_source_get_icon_path()
    if p is None: return
    if os.path.isabs(p):
      w, h = g.icon_size_lookup(g.ICON_SIZE_DND)
      try: pixbuf = g.gdk.pixbuf_new_from_file(p)
      except: pass
      else:
        pixbuf = pixbuf.scale_simple(w, h, g.gdk.INTERP_BILINEAR)
        self.drag_source_set_icon_pixbuf(pixbuf)
    else:
      self.drag_source_set_icon_stock(p)

  def dnd_source_get_icon_path(self):
    return None

  def dnd_source_get_uri(self):
    return ""
